//+------------------------------------------------------------------+
//|                                                         OBOS.mq4 |
//|                               Copyright  2012, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Green
#property indicator_color2 Yellow
#property indicator_color3 Green
#property indicator_color4 Yellow

extern int Length=9;
extern int MaxBars=100;
extern color UP_Color=Green;
extern color DN_Color=Red;
extern color OB_Color=Blue;

double Buff5[], Buff6[], Up[], Dn[];
double UpH[], DnH[], Z[];

int init()
  {
   IndicatorShortName("Overbought/Oversold Indicator");
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Up);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Dn);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,UpH);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,DnH);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Z);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(5,Buff5);
   SetIndexStyle(6,DRAW_NONE);
   SetIndexBuffer(6,Buff6);

   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
{
 if(Bars<=Length) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int pos;
 int limit=Bars-2;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 limit=MathMax(limit, MaxBars);
 pos=limit;
 double Buff1, Buff3, Buff4;
 while(pos>=0)
 {
  Buff1=(High[pos]+Low[pos]+Close[pos]+Close[pos])/4;
  Buff3=iMA(NULL, 0, Length, 0, MODE_EMA, PRICE_WEIGHTED, pos);
  Buff4=iStdDev(NULL, 0, Length, 0, MODE_EMA, PRICE_WEIGHTED, pos);
  if (Buff4!=0) 
  {
   Buff5[pos]=(Buff1-Buff3)*100/Buff4; 
  } 
  pos--;
 } 
 pos=limit;
 while(pos>=0)
 {
  Buff6[pos]=iMAOnArray(Buff5, 0, Length, 0, MODE_EMA, pos);
  pos--;
 }
 pos=limit;
 while(pos>=0)
 {
  Up[pos]=iMAOnArray(Buff6, 0, Length, 0, MODE_EMA, pos);
  pos--;
 }
 pos=limit;
 
 while(pos>=0)
 {
  Dn[pos]=iMAOnArray(Up, 0, Length, 0, MODE_EMA, pos);
  if (Up[pos]>=Dn[pos])
  {
   if (Up[pos]>0)
   {
    UpH[pos]=Up[pos];
    DnH[pos]=EMPTY_VALUE;
    Z[pos]=Dn[pos];
   }
   else
   {
    UpH[pos]=Dn[pos];
    DnH[pos]=EMPTY_VALUE;
    Z[pos]=Up[pos];
   } 
  }
  else
  {
   if (Dn[pos]>0)
   {
    UpH[pos]=EMPTY_VALUE;
    DnH[pos]=Dn[pos];
    Z[pos]=Up[pos];
   }
   else
   {
    UpH[pos]=EMPTY_VALUE;
    DnH[pos]=Up[pos];
    Z[pos]=Dn[pos];
   } 
  }
  pos--;
 }

 return(0);
}

